package employeeasystem;

import java.sql.*;
import java.util.Vector;
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author ashraful
 */
public class AttendenceForm extends javax.swing.JFrame {

    private static final String USERNAME = "root";
    private static final String PASSWORD = "robin";
    private static final String CONN_STRING = "jdbc:mysql://localhost/EMS?autoReconnect=true&useSSL=false";
    
    public static String textID, textName, textAddress;
    private static boolean exist = false;
    private static String[] IDS = {};
    private static Vector IDs = new Vector();
    private static Vector<String> employeeList = new Vector<String>();
    private static final String[] selectOneOrZero = {"1", "0"};
    public AttendenceForm() {
        initComponents();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        bgPanel = new javax.swing.JPanel();
        txtID = new javax.swing.JTextField();
        label_id = new javax.swing.JLabel();
        label_name = new javax.swing.JLabel();
        txtName = new javax.swing.JTextField();
        txtAddress = new javax.swing.JTextField();
        label_address = new javax.swing.JLabel();
        btnSubmit = new javax.swing.JButton();
        label_emp_register_title = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        success_mgs = new javax.swing.JTextPane();
        jLabel1 = new javax.swing.JLabel();
        btnDropdown = new javax.swing.JComboBox<>();
        attendenceSubmit = new javax.swing.JButton();
        oneOrZero = new javax.swing.JComboBox<>();
        btnConnect = new javax.swing.JButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        txtDoneMgs = new javax.swing.JTextPane();
        connectMgs = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        jScrollPane3 = new javax.swing.JScrollPane();
        empList = new javax.swing.JList<>();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        bgPanel.setBackground(new java.awt.Color(170, 169, 64));

        label_id.setFont(new java.awt.Font("Noto Sans", 0, 14)); // NOI18N
        label_id.setText("ID");

        label_name.setFont(new java.awt.Font("Noto Sans", 0, 14)); // NOI18N
        label_name.setText("Name");

        label_address.setFont(new java.awt.Font("Noto Sans", 0, 14)); // NOI18N
        label_address.setText("Address");

        btnSubmit.setBackground(new java.awt.Color(0, 255, 195));
        btnSubmit.setFont(new java.awt.Font("Noto Sans", 1, 12)); // NOI18N
        btnSubmit.setText("SUBMIT");
        btnSubmit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSubmitActionPerformed(evt);
            }
        });

        label_emp_register_title.setFont(new java.awt.Font("Noto Sans", 0, 24)); // NOI18N
        label_emp_register_title.setText("#Employee Regisation...");

        success_mgs.setBackground(new java.awt.Color(254, 112, 112));
        success_mgs.setFont(new java.awt.Font("Noto Sans", 1, 18)); // NOI18N
        jScrollPane1.setViewportView(success_mgs);

        jLabel1.setFont(new java.awt.Font("Noto Sans", 0, 24)); // NOI18N
        jLabel1.setText("#Employee Attendence...");

        btnDropdown.setModel(new javax.swing.DefaultComboBoxModel<>(IDs));
        btnDropdown.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnDropdownActionPerformed(evt);
            }
        });

        attendenceSubmit.setFont(new java.awt.Font("Noto Sans", 1, 12)); // NOI18N
        attendenceSubmit.setText("SUBMIT");
        attendenceSubmit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                attendenceSubmitActionPerformed(evt);
            }
        });

        oneOrZero.setModel(new javax.swing.DefaultComboBoxModel<>(selectOneOrZero));
        oneOrZero.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                oneOrZeroActionPerformed(evt);
            }
        });

        btnConnect.setBackground(new java.awt.Color(0, 255, 25));
        btnConnect.setFont(new java.awt.Font("Noto Sans", 1, 12)); // NOI18N
        btnConnect.setText("CONNECT");
        btnConnect.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnConnectActionPerformed(evt);
            }
        });

        txtDoneMgs.setFont(new java.awt.Font("Noto Sans", 1, 18)); // NOI18N
        jScrollPane2.setViewportView(txtDoneMgs);

        connectMgs.setFont(new java.awt.Font("Noto Sans", 1, 18)); // NOI18N
        connectMgs.setText("Please Connect First !!");

        jLabel2.setFont(new java.awt.Font("Noto Sans", 0, 24)); // NOI18N
        jLabel2.setText("#View Employee List...");

        empList.setFont(new java.awt.Font("Noto Sans", 0, 14)); // NOI18N
        empList.setModel(new javax.swing.AbstractListModel<String>() {
            String[] strings = { "" };
            public int getSize() { return strings.length; }
            public String getElementAt(int i) { return strings[i]; }
        });
        jScrollPane3.setViewportView(empList);

        javax.swing.GroupLayout bgPanelLayout = new javax.swing.GroupLayout(bgPanel);
        bgPanel.setLayout(bgPanelLayout);
        bgPanelLayout.setHorizontalGroup(
            bgPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(bgPanelLayout.createSequentialGroup()
                .addGroup(bgPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(bgPanelLayout.createSequentialGroup()
                        .addGap(32, 32, 32)
                        .addGroup(bgPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(label_name, javax.swing.GroupLayout.PREFERRED_SIZE, 76, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(label_id, javax.swing.GroupLayout.PREFERRED_SIZE, 76, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(label_address, javax.swing.GroupLayout.PREFERRED_SIZE, 76, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(bgPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(btnSubmit, javax.swing.GroupLayout.PREFERRED_SIZE, 122, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(txtID)
                            .addComponent(txtName, javax.swing.GroupLayout.DEFAULT_SIZE, 185, Short.MAX_VALUE)
                            .addComponent(txtAddress)))
                    .addGroup(bgPanelLayout.createSequentialGroup()
                        .addGap(22, 22, 22)
                        .addGroup(bgPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(connectMgs)
                            .addComponent(label_emp_register_title, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 283, Short.MAX_VALUE)
                            .addComponent(jScrollPane1)))
                    .addGroup(bgPanelLayout.createSequentialGroup()
                        .addGap(90, 90, 90)
                        .addComponent(btnConnect, javax.swing.GroupLayout.PREFERRED_SIZE, 115, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(46, 46, 46)
                .addGroup(bgPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 312, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(bgPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                        .addComponent(jScrollPane2, javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(bgPanelLayout.createSequentialGroup()
                            .addComponent(btnDropdown, javax.swing.GroupLayout.PREFERRED_SIZE, 97, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGap(21, 21, 21)
                            .addComponent(oneOrZero, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGap(18, 18, 18)
                            .addComponent(attendenceSubmit, javax.swing.GroupLayout.PREFERRED_SIZE, 87, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 296, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, 296, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(44, Short.MAX_VALUE))
        );
        bgPanelLayout.setVerticalGroup(
            bgPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(bgPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(bgPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(label_emp_register_title, javax.swing.GroupLayout.PREFERRED_SIZE, 48, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 46, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(bgPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE, false)
                    .addComponent(txtID)
                    .addComponent(label_id, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(btnDropdown)
                    .addComponent(attendenceSubmit, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(oneOrZero, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(bgPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(bgPanelLayout.createSequentialGroup()
                        .addGroup(bgPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(label_name, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(txtName, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(bgPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(txtAddress, javax.swing.GroupLayout.PREFERRED_SIZE, 84, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(label_address, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnSubmit, javax.swing.GroupLayout.PREFERRED_SIZE, 40, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 44, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(connectMgs, javax.swing.GroupLayout.PREFERRED_SIZE, 47, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(btnConnect, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(bgPanelLayout.createSequentialGroup()
                        .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 45, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 42, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jScrollPane3)))
                .addContainerGap(27, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(bgPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(bgPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private static String string;

    /**
     * Get the value of string
     *
     * @return the value of string
     */
    public static String getString() {
        return string;
    }

    /**
     * Set the value of string
     *
     * @param string new value of string
     */
    public static void setString(String string) {
        employeeasystem.AttendenceForm.string = string;
    }

    private void btnSubmitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSubmitActionPerformed
        // TODO add your handling code here:       
        getRegData();
        System.out.println("ID = " + textID);
        if("".equals(textID) || "".equals(textName) || "".equals(textAddress)){
            success_mgs.setText("Empty not allowed.");
        }
        else{
            dbInsert();
            if (exist){
                success_mgs.setText("ID Already Exist.");
                exist = false;
            }
            else{
                success_mgs.setText("Success!!"); 
            }          
            success_mgs.setEditable(false);
        }   
    }//GEN-LAST:event_btnSubmitActionPerformed

    private void btnDropdownActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnDropdownActionPerformed
        // TODO add your handling code here:
//        int textComboID = (int)btnDropdown.getSelectedItem();
//        System.out.println(textComboID);
    }//GEN-LAST:event_btnDropdownActionPerformed

    private void btnConnectActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnConnectActionPerformed
        // TODO add your handling code here:
        dbGetData();
        connectMgs.setText("Connected!!");
        connectMgs.setEditable(false);
        empList.setModel(new javax.swing.AbstractListModel<String>() {
            String[] strings = employeeList.toArray(new String[employeeList.size()]);
            public int getSize() { return strings.length; }
            public String getElementAt(int i) { return strings[i]; }
        });
    }//GEN-LAST:event_btnConnectActionPerformed

    private void attendenceSubmitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_attendenceSubmitActionPerformed
        // TODO add your handling code here:
        int textComboID = (int)btnDropdown.getSelectedItem();
        System.out.println(textComboID);
        String textOneOrZero = (String)oneOrZero.getSelectedItem();
        System.out.println(textOneOrZero);
         
        // Database Part
         Connection conn = null;
        try{
            conn = DriverManager.getConnection(CONN_STRING, USERNAME, PASSWORD);
            System.out.println("Connection Establised !!");
            Statement stmt = (Statement) conn.createStatement();
            
            String query = "INSERT INTO attendence (ID, status) VALUES ('"+textComboID+"', '"+textOneOrZero+"')";
//            INSERT INTO `attendence` (`ID`, `status`, `date`) VALUES ('111', '0', CURRENT_TIMESTAMP);
            stmt.executeUpdate(query);
            
            stmt.close();
            conn.close();
        }
        catch(SQLException e){
            if(e.getErrorCode() == 1062){
                exist = true;
            }
            //System.err.println(e);
        }
        if (exist){
            txtDoneMgs.setText("Already Attended.");
            exist = false;
        }
        else{
            txtDoneMgs.setText("Success!!"); 
        }
        txtDoneMgs.setEditable(false);
    }//GEN-LAST:event_attendenceSubmitActionPerformed

    private void oneOrZeroActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_oneOrZeroActionPerformed
        // TODO add your handling code here:
//        String textOneOrZero = (String)oneOrZero.getSelectedItem();
//        System.out.println(textOneOrZero);
    }//GEN-LAST:event_oneOrZeroActionPerformed

    /* My Own Workable function */
    public void getRegData(){
        textID = txtID.getText();
        textName = txtName.getText();
        textAddress = txtAddress.getText();
    }
    
    /* Database Connection Function  */
    public static void dbGetData() {
        IDs.clear();
        Connection conn = null;
        try{
            conn = DriverManager.getConnection(CONN_STRING, USERNAME, PASSWORD);
            System.out.println("Connection Establised !!");
            Statement stmt = (Statement) conn.createStatement();
            
            String query = "SELECT ID, Name FROM employee";
            ResultSet result = stmt.executeQuery(query);
            while (result.next()) {
                int iD = result.getInt("id");
                IDs.add(iD);
                String nAme = result.getString("Name");
                employeeList.add(nAme);
            }
//            for(int i=0; i<employeeList.size(); i++){
//                System.out.println(employeeList.get(i));
//            }
            
            stmt.close();
            conn.close();
        }
        catch(SQLException e){
            if(e.getErrorCode() == 1062){
                exist = true;
            }
            //System.err.println(e);
        }
    }
    
    public static void dbInsert() {
        Connection conn = null;
        try{
            conn = DriverManager.getConnection(CONN_STRING, USERNAME, PASSWORD);
            System.out.println("Connection Establised !!");
            Statement stmt = (Statement) conn.createStatement();
            
            String query = "INSERT INTO employee VALUES ('"+textID+"', '"+textName+"', '"+textAddress+"')";
            stmt.executeUpdate(query);
            
            stmt.close();
            conn.close();
        }
        catch(SQLException e){
            if(e.getErrorCode() == 1062){
                exist = true;
            }
            //System.err.println(e);
        }
    }
    
    
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(AttendenceForm.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(AttendenceForm.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(AttendenceForm.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(AttendenceForm.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new AttendenceForm().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton attendenceSubmit;
    private javax.swing.JPanel bgPanel;
    private javax.swing.JButton btnConnect;
    private javax.swing.JComboBox<String> btnDropdown;
    private javax.swing.JButton btnSubmit;
    private javax.swing.JTextField connectMgs;
    private javax.swing.JList<String> empList;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JLabel label_address;
    private javax.swing.JLabel label_emp_register_title;
    private javax.swing.JLabel label_id;
    private javax.swing.JLabel label_name;
    private javax.swing.JComboBox<String> oneOrZero;
    private javax.swing.JTextPane success_mgs;
    private javax.swing.JTextField txtAddress;
    private javax.swing.JTextPane txtDoneMgs;
    private javax.swing.JTextField txtID;
    private javax.swing.JTextField txtName;
    // End of variables declaration//GEN-END:variables
}
